
#include "mkcomplib.h"

/*===============================================================================================
== Ziplib compresion
=================================================================================================
== data : data to compress
== length : length of data to compress
== type : filelib type of the data
== temp : boolean false if we create a TI-OS variable (add the "ZIP" tag)
                  true if it's temporary
== error : pointer to return the error code
=================================================================================================
== return the handle of the compressed datas
===============================================================================================*/

CompErr zip_data(unsigned char * data, unsigned short length, unsigned char * dest, unsigned char type) {

  TREE * tree=NULL;
  short          nL;
  unsigned short comp_len;
  short          offset;

  CompErr error;

  error=study_zip(data,length,&tree,&nL,&comp_len,&offset,TRUE);

  if (error!=COMP_NO_ERR)
    return error;  

  return mk_zip(data,length,dest,tree,nL,comp_len,offset,type,TRUE);

}

