// C Source File
// Created 07/02/2004; 18:25:53

#include "mkcomptest.h"

long memini;

void print_mem(const unsigned char * text) {
  long mem=HeapAvail();
  printf("\n%s: ini=%ld     actu=%ld    diff=%ld",text,memini,mem,memini-mem);  
}

/*===============================================================================================
== call the tests
===============================================================================================*/
extern void comp_tree(TREE tree[], unsigned char * dest_caract, unsigned char nL);

void testwritetree(void) {
  unsigned char datas1[]="aaaaabbbbbbbbbbbbbbbbbbbbc";
//  unsigned char datas2[]="aaaaaaabbbbbbbbbbbbbbbbbbbbc";
  short nL;
  unsigned short stat[256];
  TREE tree[256];
  short i,j;
  short no;

  unsigned char buffer[10];
  
  clrscr();
  nL=mk_stat(stat,datas1,strlen(datas1));
  mk_tree(stat,tree,nL);
	
	clrscr();
	no=0;
	while ( no!=nL-1 ) {
		printf("\n %d : %d(%d) %d(%d) - %d : %d",no,tree[no].right_branch,tree[no].node_right,
						tree[no].left_branch,tree[no].node_left,tree[no].father,tree[no].node);
    if (no+1%8==0)
      ngetchx();
    no++;
  }
  ngetchx();
  
  comp_tree(tree,buffer,nL);

  printf("\ntree=");
  for (i=0;i<nL+nL/2;i++) {
    for (j=0;j<8;j++) {
      printf("%d",((buffer[i]&(1<<j))!=0));
    }
    printf (" %d\n",buffer[i]);
  }
  ngetchx();

}

/*===============================================================================================
== call the tests
===============================================================================================*/
void teststudyzip(void) {

  unsigned char datas1[]="aaaaabbbbbbbbbbbbbbbbbbbbc";
  TREE * tree=NULL;
  short          nL;
  unsigned short comp_len;
  short          offset;
  CompErr error;

  clrscr();

	error=study_zip(datas1,strlen(datas1),&tree,&nL,&comp_len,&offset,TRUE);
  
  printf("\nerr=%d\nnl=%d\ncomp_len=%d\noffset=%d",error,nL,comp_len,offset);
  if (error==COMP_NO_ERR)
    free(tree);
  ngetchx();

}

/*===============================================================================================
== call the tests
===============================================================================================*/
void testzip(void) {

//  testwritetree();
  teststudyzip();
 
}

